<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Asinhrono programiranje - funkcije povratnog poziva</title>
  </head>
  <body>
    <h3>Studenti i ispiti (sa informacijama o predmetima):</h3>

    <script>
      function httpGet(url, callback) {
        const httpReq = new XMLHttpRequest();
        httpReq.onreadystatechange = function () {
          if (httpReq.readyState == 4) {
            if (httpReq.status == 200) {
              const data = JSON.parse(httpReq.responseText);
              callback(null, data);
            } else {
              const err = new Error(httpReq.statusText);
              callback(err, null);
            }
          }
        };
        httpReq.open("GET", url, true);
        httpReq.send();
      }

      // Ilustracija tzv. "pakla funkcija povratnog poziva".
      // Kod ispod je vrlo tesko debagovati.
      httpGet(
        "./data/students.json",
        /* callback 1 */ function (err, students) {
          if (err) {
            console.log(
              "Doslo je do greske pri dohvatanju studenata: " + err.message
            );
            return;
          }

          for (const student of students) {
            const node = document.createElement("p");
            node.appendChild(
              document.createTextNode(
                `${student.name} ${student.surname} (${student.index})`
              )
            );
            document.body.appendChild(node);

            const examNodeList = document.createElement("ul");
            document.body.appendChild(examNodeList);

            httpGet(
              "./data/exams.json",
              /* callback 2 */ function (err, exams) {
                if (err) {
                  console.log(
                    "Doslo je do greske pri dohvatanju ispita: " + err.message
                  );
                  return;
                }

                for (const exam of exams) {
                  if (exam.studentId !== student.id) {
                    continue;
                  }

                  httpGet(
                    "./data/courses.json",
                    /* callback 3 */ function (err, courses) {
                      if (err) {
                        console.log(
                          "Doslo je do greske pri dohvatanju predmeta: " +
                            err.message
                        );
                        return;
                      }

                      for (const course of courses) {
                        if (exam.courseId !== course.id) {
                          continue;
                        }

                        const examNode = document.createElement("li");
                        examNode.appendChild(
                          document.createTextNode(
                            `${exam.final} ${exam.year} - ${course.name} (${course.espb}) - grade: ${exam.grade}, status: ${exam.status}`
                          )
                        );
                        examNodeList.appendChild(examNode);
                      }
                    }
                  );
                }
              }
            );
          }
        }
      );
    </script>
  </body>
</html>
